/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "DomainCombobox.h"


/**
 *	 Konstruktor
 */
DomainCombobox::DomainCombobox( QWidget* parent, const char* name )
	: QComboBox( parent, name ) {

	zuruecksetzen();
}



/**
 *	 ComboBox-Eigenschaft "domain" zurckgeben
 */
QString DomainCombobox::domain() const {

	// Gib Name (ber Zuordnungstabelle) zurck
	return indexZuName[ currentItem() ];
}



/**
 *	 ComboBox-Eigenschaft setzen
 */
void DomainCombobox::setDomain( const QString &name ) {
	
	bool gefunden=false;
	IndexZuName::Iterator it;
	for ( it = indexZuName.begin(); it != indexZuName.end(); ++it ) {
		if ( it.data().compare( name ) == 0 ) {
			setCurrentItem( it.key() );
			gefunden=true;
		}
	}
	if ( !gefunden ) {
		setCurrentItem(0);
	}
}



/**
 *	 ComboBox leeren und neu fllen
 */
void DomainCombobox::zuruecksetzen() {

	clear();
	insertItem( "Keine Domain (hier whlen)" );
	indexZuName.clear();
	QSqlQuery abfrage;
	abfrage.exec( "SELECT  Domain.Name  FROM  Domain;" );
	if ( abfrage.isActive() ) {
		while ( abfrage.next() ) {
			QString eintrag;
			eintrag += abfrage.value(0).toString() ;
			// Eintrag in Combobox:
			insertItem( eintrag );
			// Map aktualisieren
			indexZuName.insert( abfrage.at() + 1, abfrage.value(0).toString() );
		}
	}
}
