/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "KundenCombobox.h"


/**
 *	 Konstruktor
 */
KundenCombobox::KundenCombobox( QWidget* parent, const char* name )
	: QComboBox( parent, name ) {

	zuruecksetzen();
}



int KundenCombobox::kunde() const {

	// Gib Kundennummer (ber Zuordnungstabelle) zurck
	return indexZuID[ currentItem() ];
}



void KundenCombobox::setKunde( const int &kdnr ) {
	
	bool gefunden=false;
	IndexZuID::Iterator it;
	for ( it = indexZuID.begin(); it != indexZuID.end(); ++it ) {
		if ( it.data() == kdnr ) {
			setCurrentItem( it.key() );
			gefunden=true;
		}
	}
	if ( !gefunden ) {
		setCurrentItem(0);
	}
}



/**
 *	 ComboBox leeren und neu fllen
 */
void KundenCombobox::zuruecksetzen() {

	clear();
	insertItem( "Bitte Kunde whlen ... (*)" );
	indexZuID.clear();
	QSqlQuery abfrage;
	abfrage.exec( "SELECT  Kunde.id, Kunde.Name, Kunde.Vorname  FROM  Kunde ORDER BY  Kunde.id;" );
	if ( abfrage.isActive() ) {
		while ( abfrage.next() ) {
			QString eintrag;
			eintrag += abfrage.value(0).toString() + ": ";
			eintrag += abfrage.value(1).toString() + " ";
			eintrag += abfrage.value(2).toString();
			// Eintrag in Combobox:
			insertItem( eintrag );
			// Map aktualisieren
			indexZuID.insert( abfrage.at() + 1, abfrage.value(0).toInt() );
		}
	}
}
