/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "MailboxCombobox.h"


/**
 *	 Konstruktor
 */
MailboxCombobox::MailboxCombobox( QWidget* parent, const char* name )
	: QComboBox( parent, name ) {

	zuruecksetzen();
}



/**
 *	 ComboBox-Eigenschaft "mailbox" zurckgeben
 */
QString MailboxCombobox::mailbox() const {

	// Gib Name (ber Zuordnungstabelle) zurck
	return indexZuName[ currentItem() ];
}



/**
 *	 ComboBox-Eigenschaft setzen
 */
void MailboxCombobox::setMailbox( const QString &name ) {
	
	bool gefunden=false;
	IndexZuName::Iterator it;
	for ( it = indexZuName.begin(); it != indexZuName.end(); ++it ) {
		if ( it.data() == name ) {
			setCurrentItem( it.key() );
			gefunden=true;
		}
	}
	if ( !gefunden ) {
		setCurrentItem(0);
	}
}



/**
 *	 ComboBox leeren und neu fllen
 */
void MailboxCombobox::zuruecksetzen() {

	clear();
	insertItem( "Keine Mailbox (hier whlen)" );
	indexZuName.clear();
	QSqlQuery abfrage;
	abfrage.exec( "SELECT  Mailbox.Name, Mailbox.Speicher  FROM  Mailbox;" );
	if ( abfrage.isActive() ) {
		while ( abfrage.next() ) {
			QString eintrag;
			eintrag += abfrage.value(0).toString() +" (";
			eintrag += abfrage.value(1).toString() +" MB)";
			// Eintrag in Combobox:
			insertItem( eintrag );
			// Map aktualisieren
			indexZuName.insert( abfrage.at() + 1, abfrage.value(0).toString() );
		}
	}
}
