/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "VertragsCombobox.h"


/**
 *	 Konstruktor
 */
VertragsCombobox::VertragsCombobox( QWidget* parent, const char* name )
	: QComboBox( parent, name ) {

	zuruecksetzen();
}



int VertragsCombobox::vertrag() const {

	// Gib Kundennummer (ber Zuordnungstabelle) zurck
	return indexZuID[ currentItem() ];
}



void VertragsCombobox::setVertrag( const int &nr ) {
	
	bool gefunden=false;
	IndexZuID::Iterator it;
	for ( it = indexZuID.begin(); it != indexZuID.end(); ++it ) {
		if ( it.data() == nr ) {
			setCurrentItem( it.key() );
			gefunden=true;
		}
	}
	if ( !gefunden ) {
		setCurrentItem(1);
	}
}



/**
 *	 ComboBox leeren und neu fllen
 */
void VertragsCombobox::zuruecksetzen() {

	clear();
	insertItem( "Bitte Vertrag whlen ... (*)" );
	indexZuID.clear();
	QSqlQuery abfrage1;
	abfrage1.exec( "SELECT  Vertrag.id, Vertrag.Datum, Vertrag.Kunde  FROM  Vertrag;" );
	if ( abfrage1.isActive() ) {
		while ( abfrage1.next() ) {
			QSqlQuery abfrage2;
			abfrage2.exec( "SELECT  Kunde.id, Kunde.Name, Kunde.Vorname  FROM  Kunde  WHERE  Kunde.id = '"+ abfrage1.value(2).toString() +"';" );
			if ( abfrage2.isActive() ) {
				abfrage2.next();
				QString eintrag;
				eintrag += abfrage1.value(0).toString() +" vom ";
				eintrag += abfrage1.value(1).toDate().toString(Qt::LocalDate) +" ( Kunde ";
				eintrag += abfrage2.value(0).toString() +": ";
				eintrag += abfrage2.value(1).toString() +" ";
				eintrag += abfrage2.value(2).toString() +" )";
				// Eintrag in Combobox:
				insertItem( eintrag );
				// Map aktualisieren
				indexZuID.insert( abfrage1.at() + 1, abfrage1.value(0).toInt() );
			}
		}
	}
}
