/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */

#include "Datenbank.h"



/**
 *	Konstruktor
 */
Datenbank::Datenbank() {

	// MySQL-Treiber fr das DB-Objekt initialisieren
	DB = QSqlDatabase::addDatabase( "QMYSQL3" );
}



/**
 *	verbinden
 */
bool Datenbank::verbinden( QString host, int port, QString name, QString user, QString pass, bool ssl ) {

	// Verbindung konfigurieren, wenn Treiber initialisiert ist
   	if ( DB ) {
		DB->setHostName(host);
		DB->setDatabaseName(name);
		DB->setUserName(user);
		DB->setPassword(pass);
		DB->setPort(port);
		if ( ssl ) {
			DB->setConnectOptions("CLIENT_SSL;CLIENT_IGNORE_SPACE");
		}
		open();
		return true;
   	} else {
	   	qDebug( "Datenbank: Treiber (MySQL) konnte nicht initialisiert werden." );
		return false;
	}
}



/**
 *	DB-Test
 */
bool Datenbank::open() {
	
	if ( DB->isOpen() ) {
		qDebug( "Datenbank: bereits geffnet - wird zuerst geschlossen ...");
		DB->close();
		open();
	} else {
		if ( DB->open() ) {
			qDebug( "Datenbank: Verbindung erfolgreich hergestellt." );
		} else { 
			qDebug( "Datenbank: Verbindung konnte nicht hergestellt werden." );
			return false;
		}
	}
	return true;
}



/**
 *	
 */
QDataTable* Datenbank::getDaten( const QString &sql ) {
	
	// bergebene SQL-Anweisungen interpretieren
	sqlAuswahl = new QSqlSelectCursor( sql );
	
	// Daten aus Auswahl in Tabelle bernehmen
	ergebnisTabelle->setSqlCursor( sqlAuswahl, true, true );	
	ergebnisTabelle->refresh();

	// Spaltenbreiten anpassen
	for ( int spalte=0; spalte < ergebnisTabelle->numCols(); spalte++ ) {
		ergebnisTabelle->adjustColumn( spalte );
	}
	
	return ergebnisTabelle;
}


