/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */

#ifndef HAUPTFENSTER_H
#define HAUPTFENSTER_H



#include "GUI/GUI_HauptFenster.h"
#include "GUI/GUI_Sicherheitsabfrage.h"
#include "GUI/GUI_Mailingliste.h"

#include "Konfiguration.h"

#include "AuswahlBox/AnredeCombobox.h"
#include "AuswahlBox/KundenCombobox.h"
#include "AuswahlBox/VertragsCombobox.h"
#include "AuswahlBox/MailboxCombobox.h"
#include "AuswahlBox/DomainCombobox.h"
#include "AuswahlBox/DatenbankCombobox.h"

#include "SQLCursor/KundenCursor.h"
#include "SQLCursor/VertragsCursor.h"
#include "SQLCursor/RechnungsCursor.h"
#include "SQLCursor/BenutzerCursor.h"
#include "SQLCursor/MailboxCursor.h"
#include "SQLCursor/DomainCursor.h"
#include "SQLCursor/DatenbankCursor.h"

#include <qmessagebox.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qtable.h>
#include <qlistbox.h>
#include <qdatetime.h>
#include <qdatetimeedit.h>
#include <qdialog.h>
#include <qspinbox.h>
#include <qdatatable.h>
#include <qsqlcursor.h>
#include <qsqlresult.h>
#include <qvariant.h>
#include <qsqlselectcursor.h>
#include <qsqlform.h>
#include <qgroupbox.h>
#include <qsqlpropertymap.h>
#include <qsplashscreen.h>
#include <qthread.h>
#include <qtextedit.h>


class HauptFenster : public GUI_HauptFenster {
private:
	Konfiguration* konfiguration;
	GUI_Mailingliste* mailinglistenDialog;
	Datenbank* datenbank;
	
	void kunde_init();
	void vertrag_init();
	void rechnung_init();
	void benutzer_init();
	void mailbox_init();
	void domain_init();
	void datenbank_init();
	
	VertragsCursor*   vertragsCursor;
	KundenCursor*     kundenCursor;
	RechnungsCursor*  rechnungsCursor;
	BenutzerCursor*   benutzerCursor;
	MailboxCursor*    mailboxCursor;
	DomainCursor*     domainCursor;
	DatenbankCursor*  datenbankCursor;
	
	QSqlForm* kundenFormular;
	QSqlForm* vertragsFormular;
	QSqlForm* rechnungsFormular;
	QSqlForm* benutzerFormular;
	QSqlForm* mailboxFormular;
	QSqlForm* domainFormular;
	QSqlForm* datenbankFormular;
	
	AnredeCombobox* anredeCombobox;
	KundenCombobox* kundenCombobox;
	VertragsCombobox* vertragsComboboxR;
	VertragsCombobox* vertragsComboboxB;
	MailboxCombobox* mailboxCombobox;
	DomainCombobox* domainCombobox;
	DatenbankCombobox* datenbankCombobox;
	
protected:

	// Men-Funktionen
	void menu_einstellungen_datenbank();
	void menu_extras_mailingliste();
	void menu_hilfe_info();
	

	void kunde_neu();
	void kunde_laden();
	void kunde_speichern();
	void kunde_loeschen();
	void kunde_suchen();
	////
	void kunde_VertragNeu();

	void vertrag_neu();
	void vertrag_laden();
	void vertrag_speichern();
	void vertrag_loeschen();
	void vertrag_suchen();
	////
	void vertrag_KundeNeu();
	void vertrag_BenutzerNeu();
	void vertrag_RechnungNeu();

	void rechnung_neu();
	void rechnung_neu( QListBoxItem* eintrag );
	void rechnung_laden();
	void rechnung_speichern();
	void rechnung_loeschen();
	void rechnung_suchen();
	////
	void rechnung_aktualisieren();

	void benutzer_neu();
	void benutzer_laden();
	void benutzer_speichern();
	void benutzer_loeschen();
	void benutzer_suchen();
	////
	void benutzer_MailboxNeu();
	void benutzer_DomainNeu();
	void benutzer_DatenbankNeu();

	void mailbox_neu();
	void mailbox_laden();
	void mailbox_speichern();
	void mailbox_loeschen();
	void mailbox_suchen();

	void domain_neu();
	void domain_laden();
	void domain_speichern();
	void domain_loeschen();
	void domain_suchen();

	void datenbank_neu();
	void datenbank_laden();
	void datenbank_speichern();
	void datenbank_loeschen();
	void datenbank_suchen();

public:
	// Konstruktor
	HauptFenster();

};


#endif
