/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "Konfiguration.h"


/**
 *	Konstruktor
 */
Konfiguration::Konfiguration() {
	
	// GUI aufbauen...
	GUI_Konfiguration::GUI_Konfiguration();

	datei = new QFile( ".Kundenverwaltung.cfg" );
	DB = new Datenbank();
}


/**
 *	Konfiguration laden
 */
void Konfiguration::laden() {

	QTextStream textStream(datei);
	if ( datei->open(IO_ReadOnly) ) {
		leName->setText( textStream.readLine() );
		leHost->setText( textStream.readLine() );
		leUser->setText( textStream.readLine() );
		lePass->setText( textStream.readLine() );
		lePort->setText( textStream.readLine() );
		datei->close();
		qDebug("Konfiguration: Konfigurationsdatei erfolgreich geladen.");
	} else {
		qDebug("Konfiguration: Konfigurationsdatei konnte nicht geladen werden.");
	}
};



/**
 *	Konfiguration speichern
 */
void Konfiguration::speichern() {

	QTextStream textStream(datei);
	if ( datei->open(IO_WriteOnly) ) {
		textStream
			<< leName->text()  << endl
			<< leHost->text()  << endl
			<< leUser->text()  << endl
			<< lePass->text()  << endl
			<< lePort->text()  << endl;
		datei->close();
		qDebug("Konfiguration: Konfigurationsdatei erfolgreich gespeichert.");
		hide();
	} else {
		qDebug("Konfiguration: Konfigurationsdatei konnte nicht gespeichert werden.");		
	}
}


/**
 *	Prft Datenbankverbindung und setzt bei Erfolg den Speichern-Button aktiv
 */
bool Konfiguration::test() {
	
	if ( leHost->text() != "" && lePort->text().toInt() != 0 ) {
		DB->verbinden( leHost->text(), lePort->text().toInt(), leName->text(), leUser->text(), lePass->text(), true );
		// Speichern-Knopf nur nach erfolgreichem Test aktivieren
		if ( DB->open() ) {
			pbSpeichern->setEnabled(true);
			return true;
		} else {
			pbSpeichern->setEnabled(false);
			return false;
		}
	}
	return false;
}



/**
 *	Popup-Window mit Test-Ergebnis
 */
void Konfiguration::testMeldung() {
	
	if ( test() ) {
		QMessageBox::information( this, "Verbindungstest", "Die Daten sind korrekt - der Test war <b>erfolgreich</b>!");
	} else {
		QMessageBox::information( this, "Verbindungstest", "Die Daten sind fehlerhaft - <b>Test gescheitert</b>.");
	}
}


/**
 *	berladene show-Funktion, um erfolgreichen Test vor dem Speichern zu erzwingen
 */
void Konfiguration::show() {
	pbSpeichern->setEnabled( false );
	QWidget::show();
}



/**
 *	Gib Zeiger auf Datenbank zurck
 */
Datenbank* Konfiguration::getDB() {
	return DB;
}
