/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "KundenCursor.h"


// Konstruktor
KundenCursor::KundenCursor() : QSqlCursor( "Kunde" ) {
	
	QSqlFieldInfo feldBenutzeranzahl( "[User]", QVariant::String );
	append( feldBenutzeranzahl );
	setCalculated( feldBenutzeranzahl.name(), TRUE );
	feldBenutzeranzahl.toField().setReadOnly(true);
}


QVariant KundenCursor::calculateField( const QString & name ) {

	
	// Benutzer-Anzahl des Kunden ermitteln
	if ( name == "[User]" ) {
		QSqlQuery abfrage( 
			"SELECT  COUNT(B.Name)  \
			 FROM  Benutzer B, Vertrag V, Kunde K  \
			 WHERE B.Vertrag=V.id  \
			   AND  V.Kunde=K.id  \
			   AND K.id='"+ field("id")->value().toString() +"'"
		);
		if ( abfrage.next() ) {
			return QVariant( abfrage.value(0).toString() );
		}
	}
	return QVariant( QString::null );
}

