/*
 *  Projektarbeit zur Vorlesung "Datenbanken" von Prof. Dr. Zhou
 *
 *  "Kundenverwaltungsystem fr ein Webhosting-Unternehmen"
 *
 *  NTA FH Isny, WS 2005/2006
 *  David Mayr, 12.Info
 *
 */


#include "VertragsCursor.h"


// Konstruktor
VertragsCursor::VertragsCursor() : QSqlCursor( "Vertrag" ) {

	QSqlFieldInfo feldKunde( "_Kunde", QVariant::String );
	append( feldKunde );
	setCalculated( feldKunde.name(), TRUE );
	feldKunde.toField().setReadOnly(true);

	QSqlFieldInfo feldBenutzer( "_Benutzer", QVariant::String );
	append( feldBenutzer );
	setCalculated( feldBenutzer.name(), TRUE );
	feldBenutzer.toField().setReadOnly(true);
}



QVariant VertragsCursor::calculateField( const QString & name ) {

	QSqlQuery abfrage;
	// Kunde / Vertragspartner ermitteln
	if ( name == "_Kunde" ) {
		abfrage.exec( "SELECT Kunde.Name, Kunde.Vorname  FROM Kunde WHERE Kunde.id = '"+ field("Kunde")->value().toString() +"';" );
		if ( abfrage.next() ) {
			return QVariant( abfrage.value(0).toString() + ", " + abfrage.value(1).toString() );
		}
	}
	// Benutzerliste des Vertrags ermitteln
	if ( name == "_Benutzer" ) {
		abfrage.exec( 
			"SELECT B.Name FROM Kunde K, Vertrag V, Benutzer B  \
			 WHERE V.Kunde=K.id  \
			   AND B.Vertrag=V.id  \
			   AND V.id = '"+ field("id")->value().toString() +"'  \
			 ORDER BY B.Name;" 
		);
		QString benutzerliste="";
		while ( abfrage.next() ) {
			benutzerliste += ( abfrage.value(0).toString() + ",  " );
		}
		return QVariant( benutzerliste.remove( benutzerliste.length()-3, 3 ) );
	}
	return QVariant( QString::null );
}

