
--
-- Table structure for table `Benutzer`
--

DROP TABLE IF EXISTS `Benutzer`;
CREATE TABLE `Benutzer` (
  `Name` varchar(64) NOT NULL,
  `uid` int(10) unsigned NOT NULL,
  `Passwort` varchar(64) default NULL,
  `Speicher` int(10) unsigned NOT NULL,
  `Vertrag` int(10) unsigned NOT NULL,
  `Datenbank` varchar(64) default NULL,
  `Mailbox` varchar(64) default NULL,
  `Domain` varchar(64) default NULL,
  PRIMARY KEY  (`Name`),
  KEY `FKindex_Domain` (`Domain`),
  KEY `FKindex_Mailbox` (`Mailbox`),
  KEY `FKindex_Datenbank` (`Datenbank`),
  KEY `FKindex_Vertrag` (`Vertrag`),
  CONSTRAINT `Benutzer_ibfk_1` FOREIGN KEY (`Domain`) REFERENCES `Domain` (`Name`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `Benutzer_ibfk_2` FOREIGN KEY (`Mailbox`) REFERENCES `Mailbox` (`Name`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `Benutzer_ibfk_3` FOREIGN KEY (`Datenbank`) REFERENCES `Datenbank` (`Name`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `Benutzer_ibfk_4` FOREIGN KEY (`Vertrag`) REFERENCES `Vertrag` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Datenbank`
--

DROP TABLE IF EXISTS `Datenbank`;
CREATE TABLE `Datenbank` (
  `Name` varchar(64) NOT NULL,
  `Passwort` varchar(64) default NULL,
  `Speicher` int(11) NOT NULL,
  PRIMARY KEY  (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Domain`
--

DROP TABLE IF EXISTS `Domain`;
CREATE TABLE `Domain` (
  `Name` varchar(64) NOT NULL,
  `hatMailinglisten` tinyint(1) default '0',
  PRIMARY KEY  (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Kunde`
--

DROP TABLE IF EXISTS `Kunde`;
CREATE TABLE `Kunde` (
  `id` int(10) unsigned zerofill NOT NULL,
  `Firma` varchar(64) default NULL,
  `Anrede` varchar(64) default NULL,
  `Name` varchar(64) NOT NULL,
  `Vorname` varchar(64) default NULL,
  `Strasse` varchar(64) default NULL,
  `HausNr` varchar(8) default NULL,
  `PLZ` varchar(8) default NULL,
  `Ort` varchar(64) default NULL,
  `Telefon` varchar(64) default NULL,
  `Fax` varchar(64) default NULL,
  `Email` varchar(64) default NULL,
  `erstelltAm` date default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Mailbox`
--

DROP TABLE IF EXISTS `Mailbox`;
CREATE TABLE `Mailbox` (
  `Name` varchar(64) NOT NULL,
  `Speicher` int(10) unsigned NOT NULL,
  `Adresse` varchar(64) NOT NULL,
  PRIMARY KEY  (`Name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Rechnung`
--

DROP TABLE IF EXISTS `Rechnung`;
CREATE TABLE `Rechnung` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `Vertrag` int(10) unsigned NOT NULL,
  `Datum` date default NULL,
  `BetragNetto` float default NULL,
  `bezahlt` tinyint(1) default NULL,
  `bezahltAm` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `FKindex_Rechnung` (`Vertrag`),
  CONSTRAINT `Rechnung_ibfk_1` FOREIGN KEY (`Vertrag`) REFERENCES `Vertrag` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `Vertrag`
--

DROP TABLE IF EXISTS `Vertrag`;
CREATE TABLE `Vertrag` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `Kunde` int(10) unsigned zerofill NOT NULL,
  `Datum` date default NULL,
  `gekündigt` tinyint(1) default NULL,
  `gekündigtAm` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `FKindex_Vertrag` (`Kunde`),
  CONSTRAINT `Vertrag_ibfk_1` FOREIGN KEY (`Kunde`) REFERENCES `Kunde` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

